// TEMPORIZADORES POSIX: sncrono y asncrono
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "temporizadores.h"
#include "mensajes.h"

#include "pthread.h"
#include "sched.h"
#include "semaphore.h"


volatile int _cuenta1=0;
void  MiFuncion1(union sigval s)
{
	_cuenta1++;
	printf("UNO: %d\n",_cuenta1);

}

void* Hilo(void* param)
{
	printf("Entro en el hilo\n");

	sleep(5);
	printf("Salgo del hilo\n");

	return NULL;
}

void TestTemporizadores()
{
	timer_t id1,id2;
	struct itimerspec ispec;
	int cuenta2=0;
	struct sigevent senyal;
	pthread_t pid;

	pthread_create(&pid,NULL,Hilo,NULL);

	senyal.sigev_notify=SIGEV_THREAD;
	senyal.sigev_signo=SIGRTMIN;
	senyal.sigev_notify_function=MiFuncion1;
	senyal.sigev_value.sival_int = 5;

	timer_create(CLOCK_MONOTONIC,&senyal,&id1);	// Asncrono
	timer_create(CLOCK_MONOTONIC,NULL,&id2); // Sncrono

	ispec.it_value.tv_sec=0;
	ispec.it_value.tv_nsec= 100;
	ispec.it_interval.tv_sec=1;
	ispec.it_interval.tv_nsec=0;

	timer_settime(id1,0,&ispec,NULL);
	ispec.it_interval.tv_nsec=500000000;
	timer_settime(id2,0,&ispec,NULL);


	while (cuenta2<10)
	{
		sigset_t s=SIGRTALL;
		int cual;

		sigwait(&s,&cual);
		printf("%d\n",cuenta2);
		cuenta2++;
	}

	timer_delete(id1);
	timer_delete(id2);

	exit(1);
}


